/*
 * This file is autogenerated by the Tesla CFA compiler
 * via: ../../cfa/splc -t tesla -s tcpc tcpc.spl
 */

#include <netinet/tcp_fsm.h>

#include <sys/types.h>

#ifdef _KERNEL
#include <sys/systm.h>
#else
#include <assert.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#endif

#include <tesla/tesla_state.h>
#include <tesla/tesla_util.h>

#include "tcpc_defs.h"

struct main {
  u_int state : 5;
  u_int active_close_return : 1;
  u_int established_return : 1;
} __attribute__((__packed__));

#define MAIN_PTR(tip) ((unsigned char *)((tip)->ti_state))
#define MAIN_STATE(tip,off) ((struct main *)(MAIN_PTR(tip)+(off)+1))
#define MAIN_NUM_STATES(tip) (MAIN_PTR(tip)[0])

void
tcpc_automata_init(struct tesla_instance *tip) {
  MAIN_NUM_STATES(tip) = 1;
  MAIN_STATE(tip,0)->state = 2; /* 28 */
  MAIN_STATE(tip,0)->active_close_return = 0;
  MAIN_STATE(tip,0)->established_return = 0;
}

int
tcpc_automata_prod(struct tesla_instance *tip, u_int event)
{
  unsigned char newstate[16];
  u_int i, curpos=1;
  struct main tmpstate;
  bzero(newstate, sizeof(newstate));
  switch (event) {
  case 0:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_LAST_ACK */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 26:
        /* event 22 -> 16 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 25;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 22 -> 24 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 22;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 1:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_CLOSING */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 20:
        /* event 5 -> 6 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 21;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 2:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_ESTABLISHED */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 10:
        /* event 48 -> 17 */
        /* register active_close_return = 1 */
        /* event 48 -> 1 */
        tmpstate.active_close_return = 1;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 16;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 48 -> 21 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 24;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      case 11:
        /* event 56 -> 17 */
        /* register active_close_return = 1 */
        /* event 56 -> 1 */
        tmpstate.active_close_return = 1;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 16;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 56 -> 21 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 24;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 3:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_CLOSED */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 1:
        /* event 34 -> 35 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 4;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      case 2:
        /* event 28 -> 43 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 5;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 28 -> 54 */
        /* register established_return = 0 */
        /* event 28 -> 56 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = 0;
        tmpstate.state = 11;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 28 -> 39 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 7;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 28 -> 32 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 13;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 28 -> 58 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 12;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      case 19:
        /* event 4 -> 11 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 14;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      case 22:
        /* event 24 -> 16 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 25;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 4:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_FIN_WAIT_1 */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 16:
        /* event 1 -> 5 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 20;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 1 -> 8 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 15;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 5:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_FIN_WAIT_2 */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 15:
        /* event 8 -> 9 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 17;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 6:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_LISTEN */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 13:
        /* event 32 -> 34 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 1;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 32 -> 35 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 4;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 7:  /* EVENT_FUNC_PROLOGUE_TCP_FREE */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 4:
        /* event 35 -> 29 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 3;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      case 12:
        /* event 58 -> 29 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 3;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      case 14:
        /* event 11 -> 2 */
        switch (MAIN_STATE(tip,i)->active_close_return) {
         case 1:
          /* event 11 -> 16 */
          tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
          tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
          tmpstate.state = 25;
          memcpy(&(newstate[curpos]), &tmpstate, 1);
          curpos++;
          break;
         case 0:
          /* event 11 -> 29 */
          tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
          tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
          tmpstate.state = 3;
          memcpy(&(newstate[curpos]), &tmpstate, 1);
          curpos++;
          break;
         default:
          return 1; /* TESLA_INTERNAL_ERROR */
        }
        break;
      case 25:
        /* event 16 -> 14 */
        switch (MAIN_STATE(tip,i)->established_return) {
         case 1:
          /* event 16 -> 29 */
          tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
          tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
          tmpstate.state = 3;
          memcpy(&(newstate[curpos]), &tmpstate, 1);
          curpos++;
          break;
         case 0:
          /* event 16 -> 29 */
          tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
          tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
          tmpstate.state = 3;
          memcpy(&(newstate[curpos]), &tmpstate, 1);
          curpos++;
          break;
         default:
          return 1; /* TESLA_INTERNAL_ERROR */
        }
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 8:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_SYN_SENT */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 7:
        /* event 39 -> 43 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 5;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 39 -> 54 */
        /* register established_return = 0 */
        /* event 39 -> 56 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = 0;
        tmpstate.state = 11;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 9:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_CLOSE_WAIT */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 24:
        /* event 21 -> 22 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 26;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 10:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_SYN_RECEIVED */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 5:
        /* event 43 -> 46 */
        /* register established_return = 1 */
        /* event 43 -> 48 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = 1;
        tmpstate.state = 10;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        /* event 43 -> 50 */
        /* register active_close_return = 0 */
        /* event 43 -> 1 */
        tmpstate.active_close_return = 0;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 16;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  case 11:  /* EVENT_TP_T_STATE_ASSIGN_TCPS_TIME_WAIT */
    for (i=0; i < MAIN_NUM_STATES(tip); i++) {
      switch (MAIN_STATE(tip,i)->state) {
      case 17:
        /* event 9 -> 4 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 19;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      case 21:
        /* event 6 -> 4 */
        tmpstate.active_close_return = MAIN_STATE(tip,i)->active_close_return;
        tmpstate.established_return = MAIN_STATE(tip,i)->established_return;
        tmpstate.state = 19;
        memcpy(&(newstate[curpos]), &tmpstate, 1);
        curpos++;
        break;
      default:
        break;
      }
    }
    newstate[0] = curpos-1;
    if (newstate[0] == 0)
      return 1; /* TESLA_ERROR */
    memcpy(MAIN_PTR(tip), &newstate, sizeof(newstate));
    return 0;

  default:
    return 1; /* TESLA_UNKNOWN_EVENT */
  }
}

